﻿using UnityEngine;
using System.Linq;
using System.Collections.Generic;

namespace McDowells
{
    ////public class Testing : MonoBehaviour
    ////{

    ////    public static List<LimbBehaviour> LB = new List<LimbBehaviour>();
    ////    public static int lpointer = 0;


    ////    public void Update()
    ////    {
    ////        bool getNext  = false;
    ////        bool hasMoved = false;
    ////        if (Input.GetKeyDown(KeyCode.LeftBracket))
    ////        {
    ////            if (LB.Count == 0) {GetLimbs(); return; }

    ////            if (--lpointer < 0) lpointer = LB.Count - 1;
    ////            getNext = true;
    ////        }

    ////        else if (Input.GetKeyDown(KeyCode.RightBracket))
    ////        {
    ////            if (LB.Count == 0) { GetLimbs(); return; }

    ////            if (++lpointer > LB.Count) lpointer = 0;
    ////            getNext = true;
    ////        }

    ////        if (getNext)
    ////        {
    ////            string nextName = "";

    ////            if (lpointer >= 0 ) nextName = LB[lpointer].name;

    ////            ModAPI.Notify(@"Limb: <color=yellow>" + nextName +
    ////                    "</color> - Clothes: <color=yellow>" + (getNext ? "yes":"no") + "</color>");
    ////        }

    ////        float inco = Input.GetKey(KeyCode.LeftShift) ? 0.1f : 0.01f;

    ////        if (Input.GetKeyDown(KeyCode.Comma))
    ////        {
    ////            Transform transform = GetCloth();
    ////            //if (transform == null) return;
    ////            Vector3 moveit = transform.localPosition;
    ////            moveit.x -= .01f;
    ////            transform.localPosition = moveit;
    ////            hasMoved = true;
    ////        }

    ////        if (Input.GetKeyDown(KeyCode.Period))
    ////        {
    ////            Transform transform = GetCloth();
    ////            if (transform == null) return;
    ////            Vector3 moveit = transform.localPosition;
    ////            moveit.x += .01f;
    ////            transform.localPosition = moveit;
    ////            hasMoved = true;
    ////        }
    ////        if (Input.GetKeyDown(KeyCode.P))
    ////        {
    ////            Transform transform = GetCloth();
    ////            if (transform == null) return;
    ////            Vector3 moveit = transform.localPosition;
    ////            moveit.y += .01f;
    ////            transform.localPosition = moveit;
    ////            hasMoved = true;
    ////        }
    ////        if (Input.GetKeyDown(KeyCode.Semicolon))
    ////        {
    ////            Transform transform = GetCloth();

    ////            if (transform == null) return;
    ////            Vector3 moveit = transform.localPosition;
    ////            moveit.y -= .01f;
    ////            transform.localPosition = moveit;
    ////            hasMoved = true;
    ////        }

    ////        if (hasMoved)
    ////        {
    ////            Transform transform = GetCloth();

    ////            ModAPI.Notify("X: " + transform.position.x + " - Y: " + transform.position.y);
    ////        }

    ////    }

    //    public static Transform GetCloth()
    //    {
    //        foreach (Transform tt in LB[lpointer].transform.GetComponentsInChildren<Transform>())
    //        {
    //            if (tt.name.Contains("grimace")) return tt;
    //        }

    //        return null;
    //    }



    //    public void GetLimbs()
    //    {
    //        foreach (PhysicalBehaviour PB in Global.main.PhysicalObjectsInWorld)
    //        {
    //            ModAPI.Notify(PB.name);
    //            if (PB.transform.root.TryGetComponent<PersonBehaviour>(out PersonBehaviour person))
    //            {
    //                if (person.name.Contains("grimace"))
    //                {
    //                    LB.Clear();
    //                    ModAPI.Notify("Found Grimace");
    //                    foreach (LimbBehaviour limb in person.Limbs)
    //                    {
    //                        LB.Add(limb);
    //                    }
    //                    return;

    //                } else ModAPI.Notify("Name: " + person.name);
    //            }
    //        }
    //    }
    //}


    public class McDowells
    {
        public static float gx     = 0f;
        public static float gy     = 0f;
        public static bool doSetup = true;

        public static Dictionary<string, string> ClothingBodyMap = new Dictionary<string, string>()
        {
            {"ronald_wig",          "l:Head,x:0,y:0.05,s:6" },
            {"hamburgler_hat",      "l:Head,x:0,y:0.12"           },
            {"evil_chuck_bandana",  "l:Head,x:0,y:-0.02"          },
            {"evil_chuck_hair",     "l:Head,x:0,y:-0.02"          },
            {"grimace_head",        "l:Head,x:1.94,y:0"           },
            {"grimace_upperbody",   "l:UpperBody,x:0,y:-0.40"     },
            {"grimace_lowerbody",   "l:LowerBody,x:0,y:-0.45"     },
            {"grimace_top",         "l:MiddleBody,x:0,y:-0.11"    },
            //{"grimace_arm",         "l:LowerArmFront,x:0,y:-0.81" },
        };

        


        public static void Main()
        {
            if (doSetup)
            {
                doSetup = false;
                //  Create category button for McDowells shtuff
                Category category    = ScriptableObject.CreateInstance<Category>();
                category.name        = "McDowells";
                category.Description = "Home of the Big Mick";
                category.Icon        = ModAPI.LoadSprite("category.png");

                CatalogBehaviour.Main.Catalog.Categories = CatalogBehaviour.Main.Catalog.Categories.Append(category).ToArray();

            }

            //ModAPI.Register(
            //    new Modification()
            //    {
            //        OriginalItem          = ModAPI.FindSpawnable("Human"),
            //        NameOverride          = "Ronald McDonald",
            //        NameToOrderByOverride = "1",
            //        DescriptionOverride   = "Food folks and Fun!",
            //        CategoryOverride      = ModAPI.FindCategory("McDowells"),
            //        ThumbnailOverride     = ModAPI.LoadSprite("peeps/ronald_thumb.png", 30f),
            //        AfterSpawn            = (Instance) =>
            //        {

            //            var skin  = ModAPI.LoadTexture("peeps/ronald.png");
            //            var flesh = ModAPI.LoadTexture("6f_flesh.png");
            //            var bone  = ModAPI.LoadTexture("6f_bone.png");
            //            Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);


            //            var person = Instance.GetComponent<PersonBehaviour>();
            //            person.SetBodyTextures(skin, flesh, bone, 6);
            //        } });

            //  Add McDowell's People
            AddPerson("ronald", "ronald_wig", 6);
            AddPerson("hamburgler", "hamburgler_hat");
            AddPerson("evil_chuck", "evil_chuck_hair,evil_chuck_bandana",1);
            AddPerson("tubby_mcbutter");
            AddPerson("grimace", "grimace_top,grimace_leg,grimace_arm",1);
            //AddPerson("grimace", "Head:grimace_head,UpperBody:grimace_upperbody,grimace_lowerbody,grimace_leg");


            //  Add McDowell's Buildings
            Building McDonalds1 = new Building("mcd_1", 1f, "wood", "stick", 0, false, true);

            McDonalds1.AddPiece("mcd_1_inside", 10f, 10f, 1f, true, false, 5, 0);
            McDonalds1.Spawn();

            //ModAPI.Register<Testing>();

            
        }

        
        public static void AddPerson(string png, string clothes = null, float scale=1)
        {
            Dictionary<string, string> NameMap = new Dictionary<string, string>()
            {
                {"ronald",         "Ronald McDonald"},
                {"hamburgler",     "The Hamburgler"},
                {"grimace",        "Grimace"},
                {"evil_chuck",     "Evil Chuck Norris"},
                {"tubby_mcbutter", "Tubby McButter"},
                {"clemens",        "Old Man Clemens"},
            };

            string McName = png;
            NameMap.TryGetValue( png, out McName);


            ModAPI.Register(new Modification()
            {
                OriginalItem        = ModAPI.FindSpawnable("Human"),
                NameOverride        = McName,
                DescriptionOverride = "McDowell Peep " + png,
                CategoryOverride    = ModAPI.FindCategory("McDowells"),
                ThumbnailOverride   = ModAPI.LoadSprite("peeps/" + png + "_thumb.png"),

                AfterSpawn          = (Instance) =>
                {
                    Texture2D skin  = ModAPI.LoadTexture("peeps/" + png + "_skin.png");
                    Texture2D flesh = ModAPI.LoadTexture("peeps/_flesh_" + scale + ".png");
                    Texture2D bone  = ModAPI.LoadTexture("peeps/_bone_" + scale + ".png");

                    PersonBehaviour person = Instance.GetComponent<PersonBehaviour>();

                    Dictionary<string, LimbBehaviour> LBS = new Dictionary<string, LimbBehaviour>();

                    foreach (LimbBehaviour limb in person.Limbs) LBS.Add(limb.name, limb);
                    
                    if (png.Contains("grimace"))
                    {   
                        return;
                        Vector3 vec2 = new Vector3();
                        vec2.y -= 1.0f;

                        //LBS["UpperArmFront"].transform.localScale      = new Vector3(1.01f, 0.5f,1f);
                        ////LBS["UpperArmFront"].transform.sca
                        //LBS["LowerArmFront"].transform.localScale      = new Vector3(1.02f, 0.15f,1f);
                        
                        //LBS["UpperArmFront"].transform.localPosition = new Vector3(0f, 0.1f);
                        //LBS["LowerArmFront"].transform.localPosition = new Vector3(0f, 0.1f);
                    }


                    if (clothes != null)
                    {
                        int itemNumber = 0;

                        string[] clothesList = clothes.Split(',');

                        for (int cNumber = clothesList.Length; --cNumber >= 0;)
                        {
                            if (ClothingBodyMap.ContainsKey(clothesList[cNumber]))
                            {
                                GameObject clothingObject = new GameObject("McD " + clothesList[cNumber]);

                                string[] ClothingSetup    = ClothingBodyMap[ clothesList[cNumber]].Split(',');

                                float ClothingScale = 1f;
                                Vector3 vecTemp = new Vector3();

                                foreach (string ClothingRule in ClothingSetup)
                                {
                                    
                                    string[] RuleParts = ClothingRule.Split(':');
                                    
                                    if (RuleParts.Length == 2)
                                    {
                                        switch (RuleParts[0].ToLower())
                                        {
                                            case "x":
                                                vecTemp.x = float.Parse(RuleParts[1]);
                                                break;

                                            case "y":
                                                vecTemp.y = float.Parse(RuleParts[1]);
                                                break;

                                            case "l":
                                                clothingObject.transform.SetParent(LBS[RuleParts[1]].transform);
                                                break;

                                            case "s":
                                                ClothingScale = float.Parse(RuleParts[1]);
                                                break;

                                        }
                                    }

                                }

                                clothingObject.transform.localPosition = vecTemp;

                                clothingObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                                SpriteRenderer clothingSprite     = clothingObject.AddComponent<SpriteRenderer>();
                                clothingSprite.sprite             = ModAPI.LoadSprite("peeps/" + clothesList[cNumber] + ".png", ClothingScale);
                                clothingSprite.sortingLayerName   = "Foreground";
                                clothingSprite.sortingOrder       = cNumber;

                                foreach (LimbBehaviour body in person.Limbs)
                                {
                                    body.transform.root.localScale *= 0.997f;
                                    body.transform.localScale       = new Vector3(0.9f, 1f);
                                }

                                clothingObject.transform.localScale = new Vector3(1f, 1f);
                                clothingSprite.sortingOrder        += itemNumber;
                            }
                        }

                        //  Make head appear behind hair
                        LBS["Head"].GetComponent<SpriteRenderer>().sortingOrder = -1;
                    }

                    person.SetBodyTextures(skin, flesh, bone, scale);

                    SpriteRenderer sr1     = LBS["LowerArmFront"].GetComponent<SpriteRenderer>();
                    SpriteRenderer sr2     = LBS["LowerArm"].GetComponent<SpriteRenderer>();
                    SpriteRenderer sr3     = LBS["Head"].GetComponent<SpriteRenderer>();
                    LimbBehaviour[] LBs    = person.GetComponentsInChildren<LimbBehaviour>();
                    PhysicalBehaviour PB   = person.GetComponentInParent<PhysicalBehaviour>();
                    
                    //if (person.tag == null || person.tag != "x")
                    if (true)
                    {
                        if (png.Contains("grimace"))
                        {
                            //Vector3 vec                                  = new Vector3();
                            //vec.y                                       -= 1.0f;
                            //LBS["UpperArmFront"].transform.localPosition = new Vector3(1.1f,0.7f);
                        
                            LBS["UpperArmFront"].transform.localScale       = new Vector3(1.2f,0.7f);
                            LBS["LowerArmFront"].transform.localScale       = new Vector3(1.2f,0.7f);
                            LBS["UpperArmFront"].transform.localPosition    = new Vector3(0f,-0.7f);
                            LBS["LowerArmFront"].transform.localPosition    = new Vector3(0f,-0.9f);

                            LBS["UpperArm"].transform.localScale            = new Vector3(1.2f, 0.7f);
                            LBS["LowerArm"].transform.localScale            = new Vector3(1.2f, 0.7f);
                            LBS["UpperArm"].transform.localPosition         = new Vector3(0f, -0.7f);
                            LBS["LowerArm"].transform.localPosition         = new Vector3(0f, -0.9f);

                            LBS["UpperLeg"].transform.localScale            = new Vector3(1.2f, 0.7f);
                            LBS["LowerArm"].transform.localScale            = new Vector3(1.2f, 0.7f);
                            LBS["UpperArm"].transform.localPosition         = new Vector3(0f, -0.7f);
                            LBS["LowerArm"].transform.localPosition         = new Vector3(0f, -0.9f);
                        }

                        if (png.Contains("hamburgler"))
                        {
                            LBS["LowerLeg"].transform.localScale            = new Vector3(1f, 0.7f);
                            LBS["LowerLegFront"].transform.localScale       = new Vector3(1f, 0.7f);
                            LBS["UpperLeg"].transform.localScale            = new Vector3(1f, 0.7f);
                            LBS["UpperLegFront"].transform.localScale       = new Vector3(1f, 0.7f);
                            LBS["MiddleBody"].transform.localScale          = new Vector3(1f, 0.7f);
                            LBS["LowerBody"].transform.localScale           = new Vector3(1f, 0.7f);
                            LBS["LowerArm"].transform.localScale            = new Vector3(1f, 0.7f);
                            LBS["LowerArmFront"].transform.localScale       = new Vector3(1f, 0.7f);

                            Vector3 Position;
                        
                            // see, this is why me shoulda learned math instead of doing things the dipshit way
                            Position    = LBS["MiddleBody"].transform.position;
                            Position.y += 0.043f;
                            LBS["MiddleBody"].transform.position = Position;

                            Position    = LBS["LowerBody"].transform.position;
                            Position.y += 0.11f;
                            LBS["LowerBody"].transform.position = Position;

                            Position    = LBS["UpperLeg"].transform.position;
                            Position.y += 0.25f;
                            LBS["UpperLeg"].transform.position      = Position;
                            LBS["UpperLegFront"].transform.position = Position;

                            Position    = LBS["LowerLeg"].transform.position;
                            Position.y += 0.35f;
                        
                            LBS["LowerLeg"].transform.position      = Position;
                            LBS["LowerLegFront"].transform.position     = Position;

                            Position    = LBS["Foot"].transform.position;
                            Position.y += 0.40f;
                            LBS["Foot"].transform.position      = Position;
                            LBS["FootFront"].transform.position = Position;

                            Position    = LBS["LowerArm"].transform.position;
                            Position.y += 0.10f;
                            LBS["LowerArm"].transform.position      = Position;
                            LBS["LowerArmFront"].transform.position = Position;

                            //Transform head = LB["UpperBody"].transform;
                            //head.gameObject.AddComponent<DistanceJoint2D>();
                            //head.gameObject.AddComponent<Swanging>();


                        }

                    }
                }
            });
        }
    }
}
